<template>
    <div :class="$style.container">
        <o-table
            v-for="tableIndex in tableColumnsNumber"
            :key="tableIndex"
            :data="getDataForTable(tableIndex - 1)"
            :bordered="true"
            striped
            :mobile-cards="false"
        >
            <o-table-column v-for="(column, idx) in columns" :key="idx" v-slot="{ row }" v-bind="column">
                {{ getValue(column, row) }}
            </o-table-column>
        </o-table>
    </div>
</template>

<script>
export default {
    name: 'TablesSection',

    props: {
        items: {
            type: Array,
            default: () => [],
        },
        columns: {
            type: Array,
            default: () => [],
        },
        tablesNumber: {
            type: Number,
            default: 2,
        },
        defaultWidth: {
            type: Number,
            default: 170,
        },
    },

    data() {
        return {
            tableColumnsNumber: 10,
            rowsNumber: 1,
        }
    },

    computed: {
        // tableColumnsNumber() {
        //     return this.tablesNumber
        // },
        // rowsNumber() {
        //     console.log(this.items.length / this.tableColumnsNumber)
        //     return Math.ceil(this.items.length / this.tableColumnsNumber)
        //     // return Math.ceil(this.items.length / this.tableColumnsNumber)
        // },
    },

    created() {
        this.getTablesNumber()
        window.addEventListener('resize', this.getTablesNumber)
    },

    methods: {
        getValue(column, row) {
            let val = row[column.field]
            if (column.formatValue) return (val = column.formatValue(val))
            return val
        },
        getTablesNumber() {
            const maxTableNumber = Math.floor((window.innerWidth - 52) / (this.defaultWidth + 32))
            let tableColumnsNumber = Math.min(maxTableNumber, this.tablesNumber)

            this.rowsNumber = Math.ceil(this.items.length / tableColumnsNumber)
            const newTableColumnsNumber = Math.ceil(this.items.length / this.rowsNumber)
            if (newTableColumnsNumber < tableColumnsNumber) tableColumnsNumber = newTableColumnsNumber
            // if (tableColumnsNumber > 1 && (tableColumnsNumber - 1) * this.rowsNumber === this.items.length)
            //     tableColumnsNumber--
            this.tableColumnsNumber = tableColumnsNumber
        },
        getDataForTable(tableIndex) {
            const startIndex = tableIndex * this.rowsNumber
            return this.items.slice(startIndex, startIndex + this.rowsNumber)
        },
    },
}
</script>

<style lang="scss" module>
// @import '@/assets/styles/variables';
@import '@/assets/styles';

.container {
    // width: 100% !important;
    display: flex;
    gap: 32px;

    table {
        border: 1px solid black;
        padding: 32px;
        border-collapse: collapse;
        // margin-right: 32px !important;
        width: 170px !important;
    }

    // td,
    // th {
    //     border: 1px solid black;
    // }
    th {
        @extend %text1;
        height: 56px !important;
        padding-top: 20px !important;
        padding-bottom: 0px !important;
        padding: 36px 0px 20px 12px;
    }

    td {
        @extend %text2;
        vertical-align: middle !important;
        height: 48px !important;
        padding: 8px 12px 8px 12px;
    }

    tr:nth-of-type(2n + 2) {
        background-color: #f8f7fb;
    }
}
</style>
